#pragma once
#include "IManagerInterface.h"
#include "IServerToolWrap.h"

/*!
	インターフェースマネージャ
*/
class CInterfaceManager
{
public:
	CInterfaceManager(void);
	virtual ~CInterfaceManager(void);

	///////////////////////////////////////////////////////////////////////////////////////////////////
	//	操作
	///////////////////////////////////////////////////////////////////////////////////////////////////
	//!	開始
	void Start(CIServerToolWrap serverTool);

	//!	停止
	void Stop();

	//!	インタフェース登録
	int RegisterInterface(CUTF8String interfaceName, IManagerInterfacePtr ifRegister, IManagerInterfacePtr *oldInterface = NULL);

	//!	インターフェース登録解除
	int UnRegisterInterface(CUTF8String interfaceName, IManagerInterfacePtr ifUnRegister, IManagerInterfacePtr oldInterface = NULL);

	//!	インタフェース取得
	void *GetInterface(CUTF8String interfaceName, int ifVersion);

protected:
	/////////////////////////////////////////////////////////////////////////////////
	//	補助関数
	/////////////////////////////////////////////////////////////////////////////////
	//!	インタフェース登録
	int _RegisterInterface(CUTF8String interfaceName, IManagerInterfacePtr ifRegister, IManagerInterfacePtr *oldInterface = NULL);

	//!	検索
	int FindIndex(CUTF8String ifName);

	/////////////////////////////////////////////////////////////////////////////////
	//	内部クラス
	/////////////////////////////////////////////////////////////////////////////////
	class CRegisterdInterface
	{
	public:
		CRegisterdInterface() {};
		CRegisterdInterface(CUTF8String interfaceName, IManagerInterfacePtr ifRegister)
		{
			m_interfaceName = interfaceName;
			m_interface = ifRegister;
		};

		//!	インターフェース名
		CUTF8String					m_interfaceName;

		//!	インターフェース
		IManagerInterfacePtr	m_interface;
	};
	class CRegisterdInterfaceArray : public CSimpleArrayTemplate<CRegisterdInterface> {};

	/////////////////////////////////////////////////////////////////////////////////
	//	メンバ変数
	/////////////////////////////////////////////////////////////////////////////////
	//!	初期化フラグ
	CInterlockCounter			m_init;

	//!	クリティカルセクション
	CSyncCriticalSection		m_scopeLock;

	//!	保存中のインタフェース
	CRegisterdInterfaceArray	m_ifArray;
};

